<?php

	if(class_exists('osC_Payment_idealcheckoutmaestro') == false)
	{
		$sRootPath = dirname(dirname(dirname(dirname(__FILE__))));
		include_once($sRootPath . '/idealcheckout/includes/library.php');

		class osC_Payment_idealcheckoutmaestro extends osC_Payment
		{
			var $_code = 'idealcheckoutmaestro';

			var $_title = 'Maestro';
			var $_method_title = 'Maestro';
			var $_description = 'Betalen met Maestro.';
			var $_status = true;
			var $_sort_order = 0;

			function osC_Payment_idealcheckoutmaestro()
			{
				// $this->_status = (MODULE_PAYMENT_IDEALCHECKOUTMAESTRO_STATUS == '1') ? true : false;
				$this->_sort_order = MODULE_PAYMENT_IDEALCHECKOUTMAESTRO_SORT_ORDER;
			}

			function getJavascriptBlock() 
			{
				return '';
			}

			function selection()
			{
				// Shows in payment selection screen
				return array('id' => $this->_code, 'module' => $this->_title);
			}

			function pre_confirmation_check()
			{
				return false;
			}

			function confirmation()
			{
				// Shows in confirm screen
				return array('title' => $this->_description);
			}

			function process_button()
			{
				return '';
			}

			function process()
			{
				global $osC_Database, $osC_Currencies, $osC_ShoppingCart;

				$this->_order_id = osC_Order::insert();


				// Add transaction record to database
				$aDatabaseSettings = idealcheckout_getDatabaseSettings();

				$sStoreCode = idealcheckout_getStoreCode();
				$sGatewayCode = 'maestro';
				$sLanguageCode = 'nl'; // nl, de, en
				$sCountryCode = '';
				$sCurrencyCode = 'EUR';

				$sOrderId = $this->_order_id;
				$sOrderCode = idealcheckout_getRandomCode(32);
				$aOrderParams = array();
				$sTransactionId = idealcheckout_getRandomCode(32);
				$sTransactionCode = idealcheckout_getRandomCode(32);
				$fTransactionAmount = $osC_Currencies->formatRaw($osC_ShoppingCart->getTotal(), 'EUR');
				$sTransactionDescription = idealcheckout_getTranslation($sLanguageCode, 'idealcheckout', 'Webshop order #{0}', array($sOrderId));
				$sTransactionPaymentUrl = HTTPS_SERVER . DIR_WS_HTTPS_CATALOG . FILENAME_CHECKOUT . '?callback&module=idealcheckoutmaestro&order_id=' . $sOrderId . '&order_code=' . $sOrderCode;
				$sTransactionSuccessUrl = HTTPS_SERVER . DIR_WS_HTTPS_CATALOG . FILENAME_CHECKOUT . '?callback&module=idealcheckoutmaestro&order_id=' . $sOrderId . '&order_code=' . $sOrderCode;
				$sTransactionPendingUrl = HTTPS_SERVER . DIR_WS_HTTPS_CATALOG . FILENAME_CHECKOUT . '?callback&module=idealcheckoutmaestro&order_id=' . $sOrderId . '&order_code=' . $sOrderCode;
				$sTransactionFailureUrl = HTTPS_SERVER . DIR_WS_HTTPS_CATALOG . FILENAME_CHECKOUT . '?callback&module=idealcheckoutmaestro&order_id=' . $sOrderId . '&order_code=' . $sOrderCode;





				// Shipment data
				$sql = "SELECT * FROM `" . $aDatabaseSettings['prefix'] . "orders` WHERE (`orders_id` = '" . $this->_order_id . "') LIMIT 1;";
				if($aOrder = idealcheckout_database_getRecord($sql))
				{
					$aOrderParams['customer'] = array();

					$sCountryCode = $aOrder['delivery_country_iso2'];
					$sCountryName = ((strcasecmp($sCountryCode, 'BE') === 0) ? 'Belgie' : 'Nederland');

					list($sFirstName, $sLastName) = explode(' ', $aOrder['delivery_name'], 2);
					list($sStreetName, $sStreetNumber) = idealcheckout_splitAddress($aOrder['delivery_street_address']);

					$aOrderParams['customer']['shipment_company'] = '';
					$aOrderParams['customer']['shipment_name'] = $aOrder['delivery_name'];
					$aOrderParams['customer']['shipment_first_name'] = $sFirstName;
					$aOrderParams['customer']['shipment_last_name'] = $sLastName;
					$aOrderParams['customer']['shipment_gender'] = '';
					$aOrderParams['customer']['shipment_date_of_birth'] = '';
					$aOrderParams['customer']['shipment_phone'] = $aOrder['delivery_telephone'];
					$aOrderParams['customer']['shipment_email'] = $aOrder['customers_email_address'];
					$aOrderParams['customer']['shipment_address'] = $aOrder['delivery_street_address'];
					$aOrderParams['customer']['shipment_street_name'] = $sStreetName;
					$aOrderParams['customer']['shipment_street_number'] = $sStreetNumber;
					$aOrderParams['customer']['shipment_zipcode'] = $aOrder['delivery_postcode'];
					$aOrderParams['customer']['shipment_city'] = $aOrder['delivery_city'];
					$aOrderParams['customer']['shipment_country_code'] = $sCountryCode;
					$aOrderParams['customer']['shipment_country_name'] = $sCountryName;


					// Payment data
					$sCountryCode = $aOrder['billing_country_iso2'];
					$sCountryName = ((strcasecmp($sCountryCode, 'BE') === 0) ? 'Belgie' : 'Nederland');

					list($sFirstName, $sLastName) = explode(' ', $aOrder['billing_name'], 2);
					list($sStreetName, $sStreetNumber) = idealcheckout_splitAddress($aOrder['billing_street_address']);

					$aOrderParams['customer']['payment_company'] = '';
					$aOrderParams['customer']['payment_name'] = $aOrder['billing_name'];
					$aOrderParams['customer']['payment_first_name'] = $sFirstName;
					$aOrderParams['customer']['payment_last_name'] = $sLastName;
					$aOrderParams['customer']['payment_gender'] = '';
					$aOrderParams['customer']['payment_date_of_birth'] = '';
					$aOrderParams['customer']['payment_phone'] = $aOrder['billing_telephone'];
					$aOrderParams['customer']['payment_email'] = $aOrder['customers_email_address'];
					$aOrderParams['customer']['payment_address'] = $aOrder['billing_street_address'];
					$aOrderParams['customer']['payment_street_name'] = $sStreetName;
					$aOrderParams['customer']['payment_street_number'] = $sStreetNumber;
					$aOrderParams['customer']['payment_zipcode'] = $aOrder['billing_postcode'];
					$aOrderParams['customer']['payment_city'] = $aOrder['billing_city'];
					$aOrderParams['customer']['payment_country_code'] = $sCountryCode;
					$aOrderParams['customer']['payment_country_name'] = $sCountryName;
				}




				// Insert into #_transactions
				$sql = "INSERT INTO `" . $aDatabaseSettings['table'] . "` SET 
`id` = NULL, 
`order_id` = '" . idealcheckout_escapeSql($sOrderId) . "', 
`order_code` = '" . idealcheckout_escapeSql($sOrderCode) . "', 
`order_params` = '" . idealcheckout_escapeSql(idealcheckout_serialize($aOrderParams)) . "', 
`store_code` = " . (empty($sStoreCode) ? "NULL" : "'" . idealcheckout_escapeSql($sStoreCode) . "'") . ", 
`gateway_code` = '" . idealcheckout_escapeSql($sGatewayCode) . "', 
`language_code` = " . (empty($sLanguageCode) ? "NULL" : "'" . idealcheckout_escapeSql($sLanguageCode) . "'") . ", 
`country_code` = " . (empty($sCountryCode) ? "NULL" : "'" . idealcheckout_escapeSql($sCountryCode) . "'") . ", 
`currency_code` = '" . idealcheckout_escapeSql($sCurrencyCode) . "', 
`transaction_id` = '" . idealcheckout_escapeSql($sTransactionId) . "', 
`transaction_code` = '" . idealcheckout_escapeSql($sTransactionCode) . "', 
`transaction_params` = NULL, 
`transaction_date` = '" . idealcheckout_escapeSql(time()) . "', 
`transaction_amount` = '" . idealcheckout_escapeSql($fTransactionAmount) . "', 
`transaction_description` = '" . idealcheckout_escapeSql($sTransactionDescription) . "', 
`transaction_status` = NULL, 
`transaction_url` = NULL, 
`transaction_payment_url` = '" . idealcheckout_escapeSql($sTransactionPaymentUrl) . "', 
`transaction_success_url` = '" . idealcheckout_escapeSql($sTransactionSuccessUrl) . "', 
`transaction_pending_url` = '" . idealcheckout_escapeSql($sTransactionPendingUrl) . "', 
`transaction_failure_url` = '" . idealcheckout_escapeSql($sTransactionFailureUrl) . "', 
`transaction_log` = NULL;";

				$oQuery = $osC_Database->query($sql);
				$oQuery->execute();



				// Redirect to iDEAL Setup
				osc_redirect(HTTPS_SERVER . DIR_WS_HTTPS_CATALOG . 'idealcheckout/setup.php?order_id=' . $sOrderId . '&order_code=' . $sOrderCode);
				// osc_redirect(osc_href_link(FILENAME_CHECKOUT, 'callback&module=idealcheckoutmaestro&order_id=' . $sOrderId . '&order_code=' . $sOrderCode, 'SSL'));
			}
			
			function callback()
			{
				global $osC_Database, $osC_ShoppingCart;

				if(empty($_GET['order_id']) || empty($_GET['order_code']))
				{
					// Invalid request
				}
				else
				{
					$sOrderId = $_GET['order_id'];
					$sOrderCode = $_GET['order_code'];

					$aDatabaseSettings = idealcheckout_getDatabaseSettings();
					
					$sql = "SELECT `transaction_status`, `transaction_url` FROM `" . $aDatabaseSettings['table'] . "` WHERE (`order_id` = '" . idealcheckout_escapeSql($sOrderId) . "') AND (`order_code` = '" . idealcheckout_escapeSql($sOrderCode) . "') ORDER BY `id` DESC LIMIT 1;";
					$aRecord = idealcheckout_database_getRecord($sql);
					
					if($aRecord)
					{						
						$iOrderId = (int) $sOrderId;
						$sTransactionStatus = $aRecord['transaction_status'];
						$sTransactionUrl = $aRecord['transaction_url'];

						if(osC_Order::exists($iOrderId))
						{
							if(strcmp($sTransactionStatus, 'SUCCESS') === 0)
							{
								// Update order status
								osC_Order::process($iOrderId, 5);
								$osC_ShoppingCart->reset(true);
								
								// Redirect
								osc_redirect(osc_href_link(FILENAME_CHECKOUT, 'success', 'SSL'));
							}
							elseif(strcmp($sTransactionStatus, 'PENDING') === 0)
							{
								// Update order status
								osC_Order::process($iOrderId, 1);
								$osC_ShoppingCart->reset(true);

								// Redirect
								osc_redirect(osc_href_link(FILENAME_CHECKOUT, 'success', 'SSL'));
							}
							elseif(strcmp($sTransactionStatus, 'OPEN') === 0)
							{
								// Update order status
								osC_Order::process($iOrderId, 1);

								if($sTransactionUrl)
								{
									// Redirect
									osc_redirect($sTransactionUrl);
								}
							}
							elseif(strcmp($sTransactionStatus, 'CANCELLED') === 0) // Explicit cancel
							{
								// Update order status
								osC_Order::process($iOrderId, 8);
							}
							elseif(strcmp($sTransactionStatus, 'EXPIRED') === 0)
							{
								// Update order status
								osC_Order::process($iOrderId, 8);
							}
							elseif(strcmp($sTransactionStatus, 'FAILURE') === 0)
							{
								// Update order status
								osC_Order::process($iOrderId, 8);
							}

							// Redirect
							osc_redirect(osc_href_link(FILENAME_CHECKOUT, 'payment', 'SSL'));
						}
					}
				}
				
				echo 'Cannot verify your order and/or payment. Please contact the webmaster.';
				exit;
			}
		}
	}

?>